import isEqual from 'lodash.isequal';
import { stringifyDiff } from '../../utils/format';
export var shouldProduceEvent = function shouldProduceEvent(context, expectedEvent) {
  var environment = context.environment;

  if (environment.isExecuted()) {
    throw Error("Assertion cannot be assigned if the test was executed.");
  }

  if (environment.getAssertion() != null) {
    throw Error("The test assertion already assigned.");
  }

  environment.setAssertion(function (resolve, reject, result, error) {
    if (error) {
      return reject(new Error("expected an event, but received an error " + error));
    }

    if (!isEqual(result, expectedEvent)) {
      return reject(new Error("shouldProduceEvent assertion failed:\n " + stringifyDiff(expectedEvent, result)));
    }

    return resolve(result);
  });
  return environment.promise;
};
//# sourceMappingURL=should-produce-event.js.map