import isEqual from 'lodash.isequal';
import { makeAssertions } from './make-assertions';
import { stringifyShouldExecuteSideEffectFailure } from '../../utils/format';
export var shouldExecuteSideEffect = function shouldExecuteSideEffect(context, name) {
  for (var _len = arguments.length, args = new Array(_len > 2 ? _len - 2 : 0), _key = 2; _key < _len; _key++) {
    args[_key - 2] = arguments[_key];
  }

  var environment = context.environment;

  if (environment.isExecuted()) {
    throw Error("Assertion cannot be assigned if the test was executed.");
  }

  environment.addAssertion(function (resolve, reject, result, error) {
    if (error) {
      return reject(new Error("expected a value, but received an error " + error));
    }

    var expected = [name].concat(args);
    var index = result ? result.sideEffects.findIndex(function (executed) {
      return isEqual(executed, expected);
    }) : -1;

    if (index >= 0) {
      return resolve(result);
    }

    return reject(new Error(stringifyShouldExecuteSideEffectFailure(expected, result.sideEffects)));
  });
  return makeAssertions(context);
};
//# sourceMappingURL=should-execute-side-effect.js.map