"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports.saga = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _lodash = _interopRequireDefault(require("lodash.partial"));

var _makeAssertions = require("./make-assertions");

var _withAdapter = require("./with-adapter");

var _withEncryption = require("./with-encryption");

var _withSecretsManager = require("./with-secrets-manager");

var _allowSideEffects = require("./allow-side-effects");

var _startSideEffectsFrom = require("./start-side-effects-from");

var _makeTestEnvironment = require("./make-test-environment");

var saga = function saga(givenEventsContext, _saga) {
  var context = (0, _extends2["default"])({}, givenEventsContext, {
    saga: _saga,
    environment: (0, _makeTestEnvironment.makeTestEnvironment)((0, _extends2["default"])({}, givenEventsContext, {
      saga: _saga
    }))
  });
  return Object.assign((0, _makeAssertions.makeAssertions)(context), {
    withAdapter: (0, _lodash["default"])(_withAdapter.withAdapter, context),
    withEncryption: (0, _lodash["default"])(_withEncryption.withEncryption, context),
    withSecretsManager: (0, _lodash["default"])(_withSecretsManager.withSecretsManager, context),
    allowSideEffects: (0, _lodash["default"])(_allowSideEffects.allowSideEffects, context),
    startSideEffectsFrom: (0, _lodash["default"])(_startSideEffectsFrom.startSideEffectsFrom, context)
  });
};

exports.saga = saga;
//# sourceMappingURL=saga.js.map